#version 330

uniform mat4 MVMatrix; // now need the transform, minus perspective
uniform mat4 PMatrix;

layout (location = 0) in vec3 Position;
layout (location = 1) in vec3 Color;
layout (location = 2) in vec3 Normal;

out vec4 vs_fs_color; // sent to the rasterizer for interpolation
out vec4 vs_fs_position; // adding position, so we know where we are
out vec3 vs_fs_normal; // interpolate the normalized surface normal
out vec2 vs_fs_uv;

void main()
{
	vs_fs_normal = Normal;
	vs_fs_color = vec4(Color, 1.0);
	vs_fs_position = MVMatrix * vec4(Position, 1.0); // pre-perspective space
	gl_Position = PMatrix * (MVMatrix * vec4(Position, 1.0));
}
